// Code generated by mockery v2.53.0. DO NOT EDIT.

package plugin

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
)

// MockManager is an autogenerated mock type for the Manager type
type MockManager struct {
	mock.Mock
}

// Close provides a mock function with no fields
func (_m *MockManager) Close() {
	_m.Called()
}

// GetPlugin provides a mock function with given fields: name
func (_m *MockManager) GetPlugin(name string) (*PipelinePlugin, error) {
	ret := _m.Called(name)

	if len(ret) == 0 {
		panic("no return value specified for GetPlugin")
	}

	var r0 *PipelinePlugin
	var r1 error
	if rf, ok := ret.Get(0).(func(string) (*PipelinePlugin, error)); ok {
		return rf(name)
	}
	if rf, ok := ret.Get(0).(func(string) *PipelinePlugin); ok {
		r0 = rf(name)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*PipelinePlugin)
		}
	}

	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(name)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPlugins provides a mock function with no fields
func (_m *MockManager) GetPlugins() []*PipelinePlugin {
	ret := _m.Called()

	if len(ret) == 0 {
		panic("no return value specified for GetPlugins")
	}

	var r0 []*PipelinePlugin
	if rf, ok := ret.Get(0).(func() []*PipelinePlugin); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*PipelinePlugin)
		}
	}

	return r0
}

// GetVersionForBuiltInPlugins provides a mock function with given fields: ctx
func (_m *MockManager) GetVersionForBuiltInPlugins(ctx context.Context) (string, error) {
	ret := _m.Called(ctx)

	if len(ret) == 0 {
		panic("no return value specified for GetVersionForBuiltInPlugins")
	}

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context) (string, error)); ok {
		return rf(ctx)
	}
	if rf, ok := ret.Get(0).(func(context.Context) string); ok {
		r0 = rf(ctx)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(context.Context) error); ok {
		r1 = rf(ctx)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// LaunchPlugin provides a mock function with given fields: ctx, source, options
func (_m *MockManager) LaunchPlugin(ctx context.Context, source string, options ...LaunchOption) error {
	_va := make([]interface{}, len(options))
	for _i := range options {
		_va[_i] = options[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx, source)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for LaunchPlugin")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string, ...LaunchOption) error); ok {
		r0 = rf(ctx, source, options...)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewMockManager creates a new instance of MockManager. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockManager(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockManager {
	mock := &MockManager{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
